var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var FOutlay;
(function (FOutlay) {
    var InterfaceRules = (function () {
        function InterfaceRules(_document) {
            this._document = _document;
        }
        InterfaceRules.prototype.GetExcelTemplateFileName = function () {
            return ObasStageSettings.ExcelTemplateDirectory + "\\" + this._document.MainParametersTable.GetFieldValue("ExcelTemplate");
        };
        InterfaceRules.prototype.GetExcelFileName = function () {
            var outlayType = this._document.OutlayType;
            if (outlayType === OutlayTypes.ProjectOutlay) {
                return "\u041F\u0440\u043E\u0435\u043A\u0442 \u0431\u044E\u0434\u0436\u0435\u0442\u043D\u043E\u0439 \u0441\u043C\u0435\u0442\u044B.xls";
            }
            else if (outlayType === OutlayTypes.Outlay || outlayType === OutlayTypes.DeltaOutlay) {
                if (this._document.DocType === 1) {
                    return "\u0411\u044E\u0434\u0436\u0435\u0442\u043D\u0430\u044F \u0441\u043C\u0435\u0442\u0430 (\u0444. 0501019).xls";
                }
                else {
                    return "\u0418\u0437\u043C\u0435\u043D\u0435\u043D\u0438\u0435 \u043F\u043E\u043A\u0430\u0437\u0430\u0442\u0435\u043B\u0435\u0439 \u0431\u044E\u0434\u0436\u0435\u0442\u043D\u043E\u0439 \u0441\u043C\u0435\u0442\u044B (\u0444. 0501020).xls";
                }
            }
            else if (outlayType === OutlayTypes.ProjectSumOutlay) {
                return "\u0421\u0432\u043E\u0434 \u043F\u0440\u043E\u0435\u043A\u0442\u043E\u0432 \u0431\u044E\u0434\u0436\u0435\u0442\u043D\u044B\u0445 \u0441\u043C\u0435\u0442.xls";
            }
            else if (outlayType === OutlayTypes.SumOutlay) {
                if (this._document.DocType === 1) {
                    return "\u0421\u0432\u043E\u0434 \u0431\u044E\u0434\u0436\u0435\u0442\u043D\u044B\u0445 \u0441\u043C\u0435\u0442.xls";
                }
                else {
                    return "\u0418\u0437\u043C\u0435\u043D\u0435\u043D\u0438\u0435 \u043F\u043E\u043A\u0430\u0437\u0430\u0442\u0435\u043B\u0435\u0439 \u0441\u0432\u043E\u0434\u0430 \u0431\u044E\u0434\u0436\u0435\u0442\u043D\u044B\u0445 \u0441\u043C\u0435\u0442.xls";
                }
            }
        };
        InterfaceRules.prototype.SilentExport = function (exportDir) {
            this._document.ExportToExcel(this.GetExcelTemplateFileName(), this.GetExcelFileName(), true, false, exportDir);
        };
        InterfaceRules.prototype.HideLables = function () {
            Client.SetComponentText(ClientComponents.lblKBK, this.GetExcelFileName());
            Client.SetComponentText(ClientComponents.lblKbkName, "");
            Client.SetComponentText(ClientComponents.lblName, "");
            Client.SetComponentText(ClientComponents.lblNameLbl, "");
        };
        InterfaceRules.prototype.ExportToExcel = function () {
            this.SilentExport(ObasHelper.GetExportDirectory());
        };
        InterfaceRules.prototype.ViewPart5sp3p1LoadEventHandler = function (tableId) {
            var tableRules = this._document.TableRules;
            return tableRules.CheckByFilterPart5sp3(tableRules._filterPart5_3_1);
        };
        InterfaceRules.prototype.ViewPart5sp3p2LoadEventHandler = function (tableId) {
            var tableRules = this._document.TableRules;
            return tableRules.CheckByFilterPart5sp3(tableRules._filterPart5_3_2);
        };
        InterfaceRules.prototype.ViewPart5sp3p3LoadEventHandler = function (tableId) {
            var tableRules = this._document.TableRules;
            return tableRules.CheckByFilterPart5sp3(tableRules._filterPart5_3_3);
        };
        InterfaceRules.prototype.ViewDetailAnalyticsData = function (sheetId, sumAnakyticsKey) {
            var outlayType = this._document.OutlayType;
            if (outlayType === OutlayTypes.ProjectSumOutlay || outlayType === OutlayTypes.SumOutlay) {
                var part = sheetId.replace("Sheet_R", "").replace(/_/g, ".");
                if (part.length > 3) {
                    part = part.substring(0, 3);
                }
                var analyticsDataTable = null;
                if (part === "4") {
                    analyticsDataTable = ObasTableCollection.RroOutlaySumByAnalyticsPart4Table;
                }
                else if (part === "5.3") {
                    analyticsDataTable = ObasTableCollection.RroOutlaySumByAnalyticsPart5xxTable;
                }
                else {
                    analyticsDataTable = ObasTableCollection.RroOutlaySumByAnalyticsTable;
                }
                analyticsDataTable.Locate(analyticsDataTable.RecordKey.Id, sumAnakyticsKey);
                var keyValues = analyticsDataTable.GetKbkKeyFieldsValue();
                if (part !== "5.3") {
                    keyValues.push(analyticsDataTable.Kosgu.ForeignKey.Value);
                    keyValues.push(analyticsDataTable.AddAnalyticIndicator.ForeignKey.Value);
                }
                var rroSumOutlayKey = analyticsDataTable.RroSumOutlay.ForeignKey.Value;
                var rroHistoryBuildAnalyticsDataTable = ObasTableCollection.RroHistoryBuildAnalyticsDataTable;
                rroHistoryBuildAnalyticsDataTable.UpdateDataRows(part, keyValues, rroSumOutlayKey);
                this._document.DetailAnalyticsDataListEditor.Show(EditorShowMode.Preview);
                rroHistoryBuildAnalyticsDataTable.DeleteAllRow();
            }
        };
        return InterfaceRules;
    }());
    FOutlay.InterfaceRules = InterfaceRules;
    var DataColumns;
    (function (DataColumns) {
        DataColumns[DataColumns["Rub"] = 0] = "Rub";
        DataColumns[DataColumns["Usd"] = 1] = "Usd";
        DataColumns[DataColumns["Code"] = 2] = "Code";
    })(DataColumns || (DataColumns = {}));
    var BaseGroupSheet = (function (_super) {
        __extends(BaseGroupSheet, _super);
        function BaseGroupSheet(document, _startDataColumn, _blockColumnCount) {
            var _this = _super.call(this, document) || this;
            _this._startDataColumn = _startDataColumn;
            _this._blockColumnCount = _blockColumnCount;
            return _this;
        }
        BaseGroupSheet.prototype.CalcStartBlockColumn = function (block) {
            return this._startDataColumn + this._blockColumnCount * block;
        };
        BaseGroupSheet.prototype.CalcEndBlockColumn = function (block) {
            return this._startDataColumn + this._blockColumnCount * (block + 1) - 1;
        };
        BaseGroupSheet.prototype.IsDataColumn = function (column) {
            return this.CalcOffsetCol(column) >= 0;
        };
        BaseGroupSheet.prototype.CalcDataColumnBlock = function (column) {
            return (this.CalcOffsetCol(column) / this._blockColumnCount) | 0;
        };
        BaseGroupSheet.prototype.IsColumnInDataBlock = function (column, block) {
            return ((this.CalcDataColumnBlock(column) === block) && this.IsDataColumn(column));
        };
        BaseGroupSheet.prototype.CalcRelColumn = function (column) {
            return this.CalcOffsetCol(column) % this._blockColumnCount;
        };
        BaseGroupSheet.prototype.CalcOffsetCol = function (column) {
            return column - this._startDataColumn;
        };
        return BaseGroupSheet;
    }(YearGroupSheet));
    var P1GroupSheet = (function (_super) {
        __extends(P1GroupSheet, _super);
        function P1GroupSheet(document, sheetId, tableId) {
            var _this = _super.call(this, document, 5, 3) || this;
            _this.sheetId = sheetId;
            _this.tableId = tableId;
            return _this;
        }
        P1GroupSheet.prototype.IsDualRow = function (sheet, row) {
            return sheet.GetCellValue(row, 0, true) === "";
        };
        P1GroupSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            var sheet = this.Document.Sheets.getValue(sheetId);
            var rowLvl = sheet.GetRowLevel(row);
            if (column === P1GroupSheet._rowNameColumn) {
                if (row === sheet.RowCount - 1) {
                    return P1GroupSheet._totalName;
                }
                else if (this.IsDualRow(sheet, row)) {
                    return P1GroupSheet._subtotalName;
                }
            }
            if (this.IsDataColumn(column)) {
                var relColumn = this.CalcRelColumn(column);
                switch (relColumn) {
                    case DataColumns.Rub:
                        if (row === sheet.RowCount - 1) {
                            var result = 0;
                            var table = this.Document.Tables.getValue(this.tableId);
                            var reader = table.CreateReader();
                            while (reader.Read()) {
                                if (table.GetFieldValue("Level") === 1) {
                                    result += table.GetFieldValue(fieldId.replace("Fake_", ""));
                                }
                            }
                            return result;
                        }
                        else if (this.IsDualRow(sheet, row)) {
                            var result = 0;
                            var fcrSectionCode = sheet.GetCellValue(row - 1, 0, true);
                            var table = this.Document.Tables.getValue(this.tableId);
                            var reader = table.CreateReader();
                            while (reader.Read()) {
                                if ((table.GetFieldValue("Level") === 1) && (table.GetFieldValue("FCRCodeSection") === fcrSectionCode)) {
                                    result += table.GetFieldValue(fieldId.replace("Fake_", ""));
                                }
                            }
                            return result;
                        }
                        break;
                    case DataColumns.Usd:
                    case DataColumns.Code:
                        if (this.IsDualRow(sheet, row)) {
                            return ObasHelper.X;
                        }
                }
            }
        };
        P1GroupSheet.prototype.GetRecordKey = function () {
            var table = this.Document.Tables.getValue(this.tableId);
            var sheet = this.Document.Sheets.getValue(this.sheetId);
            return sheet.Table.GetKeyBySourceTable(table);
        };
        P1GroupSheet.prototype.ViewDetailDataMenuItemClickEventHandler = function () {
            if (this.ViewDetailDataMenuItemShowEventHandler() && this.ViewDetailDataMenuItemVisibleEventHandler()) {
                this.Document.InterfaceRules.ViewDetailAnalyticsData(this.sheetId, this.GetRecordKey());
            }
        };
        P1GroupSheet.prototype.ViewDetailDataMenuItemShowEventHandler = function () {
            return (this.GetRecordKey() != null);
        };
        P1GroupSheet.prototype.ViewDetailDataMenuItemVisibleEventHandler = function () {
            var outlayType = this.Document.OutlayType;
            return (outlayType === OutlayTypes.ProjectSumOutlay || outlayType === OutlayTypes.SumOutlay);
        };
        P1GroupSheet._totalName = "\u0412\u0441\u0435\u0433\u043E";
        P1GroupSheet._subtotalName = "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u043A\u043E\u0434\u0443 \u0411\u041A";
        P1GroupSheet._rowNameColumn = 4;
        return P1GroupSheet;
    }(BaseGroupSheet));
    FOutlay.P1GroupSheet = P1GroupSheet;
    var PXGroupSheet = (function (_super) {
        __extends(PXGroupSheet, _super);
        function PXGroupSheet(document, sheetId, tableId) {
            var _this = _super.call(this, document, 7, 3) || this;
            _this.sheetId = sheetId;
            _this.tableId = tableId;
            return _this;
        }
        PXGroupSheet.prototype.IsDualRow = function (sheet, row) {
            return sheet.GetCellValue(row, 5, true) === "";
        };
        PXGroupSheet.prototype.GetPrevRowCode = function (sheet, row, column) {
            row--;
            while (row > -1) {
                var prevCode = sheet.GetCellValue(row, column, true) || "";
                if (prevCode.length > 0) {
                    return parseInt(prevCode, 10);
                }
                row--;
            }
            return 0;
        };
        PXGroupSheet.prototype.CalcRowCode = function (sheet, row, column) {
            var result = this.GetPrevRowCode(sheet, row, column) + 10;
            return ObasHelper.FillWithCharacter(result, 4);
        };
        PXGroupSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            var sheet = this.Document.Sheets.getValue(sheetId);
            var rowLvl = sheet.GetRowLevel(row);
            if (column === PXGroupSheet._rowNameColumn) {
                if (row === sheet.RowCount - 1) {
                    return PXGroupSheet._totalName;
                }
                else if (this.IsDualRow(sheet, row)) {
                    return PXGroupSheet._subtotalName;
                }
            }
            else if (column === 1) {
                if (this.IsDualRow(sheet, row)) {
                    return "";
                }
                else if ((this.IsDualRow(sheet, row - 1) || (row === 0))) {
                    return "0100";
                }
                else {
                    return this.CalcRowCode(sheet, row, column);
                }
            }
            else if (column === 2) {
                if (this.IsDualRow(sheet, row) && (row != sheet.RowCount - 1)) {
                    return sheet.GetCellValue(row - 1, column, true);
                }
            }
            else if (column === 3) {
                if (this.IsDualRow(sheet, row) && (row != sheet.RowCount - 1)) {
                    return "00";
                }
            }
            if (this.IsDataColumn(column)) {
                var relColumn = this.CalcRelColumn(column);
                switch (relColumn) {
                    case DataColumns.Rub:
                        if (row === sheet.RowCount - 1) {
                            var result = 0;
                            var table = this.Document.Tables.getValue(this.tableId);
                            var reader = table.CreateReader();
                            while (reader.Read()) {
                                if (table.GetFieldValue("Level") === 1) {
                                    result += table.GetFieldValue(fieldId.replace("Fake_", ""));
                                }
                            }
                            return result;
                        }
                        else if (this.IsDualRow(sheet, row)) {
                            var result = 0;
                            var fcrSectionCode = sheet.GetCellValue(row - 1, 2, true);
                            var table = this.Document.Tables.getValue(this.tableId);
                            var reader = table.CreateReader();
                            while (reader.Read()) {
                                if ((table.GetFieldValue("Level") === 1) && (table.GetFieldValue("FCRCodeSection") === fcrSectionCode)) {
                                    result += table.GetFieldValue(fieldId.replace("Fake_", ""));
                                }
                            }
                            return result;
                        }
                        break;
                    case DataColumns.Usd:
                    case DataColumns.Code:
                        if (this.IsDualRow(sheet, row)) {
                            return ObasHelper.X;
                        }
                }
            }
        };
        PXGroupSheet.prototype.GetRecordKey = function () {
            var table = this.Document.Tables.getValue(this.tableId);
            var sheet = this.Document.Sheets.getValue(this.sheetId);
            return sheet.Table.GetKeyBySourceTable(table);
        };
        PXGroupSheet.prototype.ViewDetailDataMenuItemClickEventHandler = function () {
            if (this.ViewDetailDataMenuItemShowEventHandler() && this.ViewDetailDataMenuItemVisibleEventHandler()) {
                this.Document.InterfaceRules.ViewDetailAnalyticsData(this.sheetId, this.GetRecordKey());
            }
        };
        PXGroupSheet.prototype.ViewDetailDataMenuItemShowEventHandler = function () {
            return (this.GetRecordKey() != null);
        };
        PXGroupSheet.prototype.ViewDetailDataMenuItemVisibleEventHandler = function () {
            var outlayType = this.Document.OutlayType;
            return (outlayType === OutlayTypes.ProjectSumOutlay || outlayType === OutlayTypes.SumOutlay);
        };
        PXGroupSheet._totalName = "\u0412\u0441\u0435\u0433\u043E";
        PXGroupSheet._subtotalName = "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u043A\u043E\u0434\u0443 \u0411\u041A";
        PXGroupSheet._rowNameColumn = 0;
        return PXGroupSheet;
    }(BaseGroupSheet));
    FOutlay.PXGroupSheet = PXGroupSheet;
    var KbkColumns;
    (function (KbkColumns) {
        KbkColumns[KbkColumns["FcrSectionCode"] = 2] = "FcrSectionCode";
        KbkColumns[KbkColumns["FcrSubSectionCode"] = 3] = "FcrSubSectionCode";
        KbkColumns[KbkColumns["CsrCode"] = 4] = "CsrCode";
        KbkColumns[KbkColumns["VrCode"] = 5] = "VrCode";
    })(KbkColumns || (KbkColumns = {}));
    var P2GroupSheet = (function (_super) {
        __extends(P2GroupSheet, _super);
        function P2GroupSheet(document, sheetId, tableId, tablePart4Id) {
            var _this = _super.call(this, document, 7, 3) || this;
            _this.sheetId = sheetId;
            _this.tableId = tableId;
            _this.tablePart4Id = tablePart4Id;
            return _this;
        }
        P2GroupSheet.prototype.IsDualRow = function (sheet, row) {
            return sheet.GetCellValue(row, 5, true) === "";
        };
        P2GroupSheet.prototype.GetPrevRowCode = function (sheet, row, column) {
            row--;
            while (row > -1) {
                var prevCode = sheet.GetCellValue(row, column, true) || "";
                if (prevCode.length > 0) {
                    return parseInt(prevCode, 10);
                }
                row--;
            }
            return 0;
        };
        P2GroupSheet.prototype.CalcRowCode = function (sheet, row, column) {
            var result = this.GetPrevRowCode(sheet, row, column) + 10;
            return ObasHelper.FillWithCharacter(result, 4);
        };
        P2GroupSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            var sheet = this.Document.Sheets.getValue(sheetId);
            var rowLvl = sheet.GetRowLevel(row);
            if (column === P2GroupSheet._rowNameColumn) {
                if (row === sheet.RowCount - 1) {
                    return P2GroupSheet._totalName;
                }
                else if (this.IsDualRow(sheet, row)) {
                    return P2GroupSheet._subtotalName;
                }
            }
            else if (column === 1) {
                if (this.IsDualRow(sheet, row)) {
                    return "";
                }
                else if ((this.IsDualRow(sheet, row - 1) || (row === 0))) {
                    return "0100";
                }
                else {
                    return this.CalcRowCode(sheet, row, column);
                }
            }
            else if (column === 2) {
                if (this.IsDualRow(sheet, row) && (row != sheet.RowCount - 1)) {
                    return sheet.GetCellValue(row - 1, column, true);
                }
            }
            else if (column === 3) {
                if (this.IsDualRow(sheet, row) && (row != sheet.RowCount - 1)) {
                    return "00";
                }
            }
            if (this.IsDataColumn(column)) {
                var relColumn = this.CalcRelColumn(column);
                switch (relColumn) {
                    case DataColumns.Rub:
                        if (row === sheet.RowCount - 1) {
                            var result = 0;
                            var table = this.Document.Tables.getValue(this.tableId);
                            var reader = table.CreateReader();
                            while (reader.Read()) {
                                if (table.GetFieldValue("Level") === 1) {
                                    result += table.GetFieldValue(fieldId.replace("Fake_", ""));
                                }
                            }
                            var tablePart4 = this.Document.Tables.getValue(this.tablePart4Id);
                            var reader = tablePart4.CreateReader();
                            while (reader.Read()) {
                                if (tablePart4.GetFieldValue("Level") === 1) {
                                    result -= tablePart4.GetFieldValue(fieldId.replace("Fake_", ""));
                                }
                            }
                            return result;
                        }
                        else if (this.IsDualRow(sheet, row)) {
                            var result = 0;
                            var fcrSectionCode = sheet.GetCellValue(row - 1, 2, true);
                            var table = this.Document.Tables.getValue(this.tableId);
                            var reader = table.CreateReader();
                            while (reader.Read()) {
                                if ((table.GetFieldValue("Level") === 1) && (table.GetFieldValue("FCRCodeSection") === fcrSectionCode)) {
                                    result += table.GetFieldValue(fieldId.replace("Fake_", ""));
                                }
                            }
                            var tablePart4 = this.Document.Tables.getValue(this.tablePart4Id);
                            var reader = tablePart4.CreateReader();
                            while (reader.Read()) {
                                if ((tablePart4.GetFieldValue("Level") === 1) && (tablePart4.GetFieldValue("FCRCodeSection") === fcrSectionCode)) {
                                    result -= tablePart4.GetFieldValue(fieldId.replace("Fake_", ""));
                                }
                            }
                            return result;
                        }
                        else {
                            var fcrSectionCode = sheet.GetCellValue(row, KbkColumns.FcrSectionCode, true);
                            var fcrSubSectionCode = sheet.GetCellValue(row, KbkColumns.FcrSubSectionCode, true);
                            var csrCode = sheet.GetCellValue(row, KbkColumns.CsrCode, true);
                            var vrCode = sheet.GetCellValue(row, KbkColumns.VrCode, true);
                            var kosguCode = sheet.GetCellValue(row, KbkColumns.VrCode + 1, true);
                            var result = sheet.GetCellValue(row, column, true);
                            var tablePart4 = this.Document.Tables.getValue(this.tablePart4Id);
                            if (tablePart4.Locate(["FCR_CodeSection", "FCR_CodeSubSection", "CSR_Code", "VR_Code", "AnalyticCode"], [fcrSectionCode, fcrSubSectionCode, csrCode, vrCode, kosguCode])) {
                                result -= tablePart4.GetFieldValue(fieldId.replace("Fake_", ""));
                            }
                            return result;
                        }
                        break;
                    case DataColumns.Usd:
                    case DataColumns.Code:
                        if (this.IsDualRow(sheet, row)) {
                            return ObasHelper.X;
                        }
                }
            }
        };
        P2GroupSheet.prototype.GetRecordKey = function () {
            var table = this.Document.Tables.getValue(this.tableId);
            var sheet = this.Document.Sheets.getValue(this.sheetId);
            return sheet.Table.GetKeyBySourceTable(table);
        };
        P2GroupSheet.prototype.ViewDetailDataMenuItemClickEventHandler = function () {
            if (this.ViewDetailDataMenuItemShowEventHandler() && this.ViewDetailDataMenuItemVisibleEventHandler()) {
                this.Document.InterfaceRules.ViewDetailAnalyticsData(this.sheetId, this.GetRecordKey());
            }
        };
        P2GroupSheet.prototype.ViewDetailDataMenuItemShowEventHandler = function () {
            return (this.GetRecordKey() != null);
        };
        P2GroupSheet.prototype.ViewDetailDataMenuItemVisibleEventHandler = function () {
            var outlayType = this.Document.OutlayType;
            return (outlayType === OutlayTypes.ProjectSumOutlay || outlayType === OutlayTypes.SumOutlay);
        };
        P2GroupSheet._totalName = "\u0412\u0441\u0435\u0433\u043E";
        P2GroupSheet._subtotalName = "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u043A\u043E\u0434\u0443 \u0411\u041A";
        P2GroupSheet._rowNameColumn = 0;
        return P2GroupSheet;
    }(BaseGroupSheet));
    FOutlay.P2GroupSheet = P2GroupSheet;
    var P5sp3xGroupSheet = (function (_super) {
        __extends(P5sp3xGroupSheet, _super);
        function P5sp3xGroupSheet(document, sheetId, filter) {
            var _this = _super.call(this, document, 4, 1) || this;
            _this.sheetId = sheetId;
            _this.filter = filter;
            return _this;
        }
        P5sp3xGroupSheet.prototype.IsDualRow = function (sheet, row) {
            return sheet.GetCellValue(row, 0, true) === "";
        };
        P5sp3xGroupSheet.prototype.GetPrevRowCode = function (sheet, row, column) {
            row--;
            while (row > -1) {
                var prevCode = sheet.GetCellValue(row, column, true) || "";
                if (prevCode.length > 0) {
                    return parseInt(prevCode, 10);
                }
                row--;
            }
            return 0;
        };
        P5sp3xGroupSheet.prototype.CalcRowCode = function (sheet, row, column) {
            var result = this.GetPrevRowCode(sheet, row, column) + 100;
            return ObasHelper.FillWithCharacter(result, 4);
        };
        P5sp3xGroupSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            var sheet = this.Document.Sheets.getValue(sheetId);
            if (column === P5sp3xGroupSheet._rowNameColumn) {
                if (row === sheet.RowCount - 1) {
                    return P5sp3xGroupSheet._totalName;
                }
                else if (this.IsDualRow(sheet, row)) {
                    return P5sp3xGroupSheet._subtotalName;
                }
            }
            else if (column === 7) {
                if (this.IsDualRow(sheet, row)) {
                    return "";
                }
                else if ((this.IsDualRow(sheet, row - 1) || (row === 0))) {
                    return "0100";
                }
                else {
                    return this.CalcRowCode(sheet, row, column);
                }
            }
            if ((this.CalcOffsetCol(column) >= 0) && (this.CalcOffsetCol(column) <= 2)) {
                if (row === sheet.RowCount - 1) {
                    var result = 0;
                    var table = ObasTableCollection.RroOutlaySumByAnalyticsPart5xxTable;
                    var reader = table.CreateReader();
                    while (reader.Read()) {
                        if (this.Document.TableRules.CheckByFilterPart5sp3(this.filter)) {
                            result += table.GetFieldValue(fieldId);
                        }
                    }
                    return result;
                }
                else if (this.IsDualRow(sheet, row)) {
                    var result = 0;
                    var fcrSectionCode = sheet.GetCellValue(row - 1, 0, true);
                    var table = ObasTableCollection.RroOutlaySumByAnalyticsPart5xxTable;
                    var reader = table.CreateReader();
                    while (reader.Read()) {
                        if ((table.GetFieldValue("FCRCodeSection") === fcrSectionCode) && (this.Document.TableRules.CheckByFilterPart5sp3(this.filter))) {
                            result += table.GetFieldValue(fieldId);
                        }
                    }
                    return result;
                }
            }
            else if ((column > 7) && this.IsDualRow(sheet, row)) {
                return ObasHelper.X;
            }
        };
        P5sp3xGroupSheet.prototype.CanEditEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            var sheet = this.Document.Sheets.getValue(sheetId);
            var result = !this.IsDualRow(sheet, row);
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column > 7) {
                return result && table.GetKeyBySourceTable(ObasTableCollection.RroOutlayOrgTableWithParentTable) != null;
            }
            else {
                return result && column != 7;
            }
        };
        P5sp3xGroupSheet.prototype.CanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            var sheet = this.Document.Sheets.getValue(sheetId);
            return (column != 7 && !this.IsDualRow(sheet, row)) || (column < 7 && this.IsDualRow(sheet, row));
        };
        P5sp3xGroupSheet.prototype.CanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            var sheet = this.Document.Sheets.getValue(sheetId);
            return column != 7 && !this.IsDualRow(sheet, row);
        };
        P5sp3xGroupSheet.prototype.GetRecordKey = function () {
            var table = ObasTableCollection.RroOutlaySumByAnalyticsPart5xxTable;
            var sheet = this.Document.Sheets.getValue(this.sheetId);
            return sheet.Table.GetKeyBySourceTable(table);
        };
        P5sp3xGroupSheet.prototype.ViewDetailDataMenuItemClickEventHandler = function () {
            if (this.ViewDetailDataMenuItemShowEventHandler() && this.ViewDetailDataMenuItemVisibleEventHandler()) {
                this.Document.InterfaceRules.ViewDetailAnalyticsData(this.sheetId, this.GetRecordKey());
            }
        };
        P5sp3xGroupSheet.prototype.ViewDetailDataMenuItemShowEventHandler = function () {
            return (this.GetRecordKey() != null);
        };
        P5sp3xGroupSheet.prototype.ViewDetailDataMenuItemVisibleEventHandler = function () {
            var outlayType = this.Document.OutlayType;
            return (outlayType === OutlayTypes.ProjectSumOutlay || outlayType === OutlayTypes.SumOutlay);
        };
        P5sp3xGroupSheet._totalName = "\u0412\u0441\u0435\u0433\u043E";
        P5sp3xGroupSheet._subtotalName = "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u043A\u043E\u0434\u0443 \u0411\u041A";
        P5sp3xGroupSheet._rowNameColumn = 3;
        return P5sp3xGroupSheet;
    }(BaseGroupSheet));
    FOutlay.P5sp3xGroupSheet = P5sp3xGroupSheet;
    var BaseEditor = (function (_super) {
        __extends(BaseEditor, _super);
        function BaseEditor(id, _document) {
            var _this = _super.call(this, EditorProObjectTypes.Editor, id) || this;
            _this._document = _document;
            _this._mode = null;
            _this._systemEditor = null;
            return _this;
        }
        Object.defineProperty(BaseEditor.prototype, "SystemEditor", {
            get: function () {
                if (this._systemEditor == null) {
                    this._systemEditor = this._document.Editors.getValue(this.Id);
                }
                return this._systemEditor;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BaseEditor.prototype, "Sheets", {
            get: function () {
                return this.SystemEditor.Sheets;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BaseEditor.prototype, "Document", {
            get: function () {
                return this._document;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BaseEditor.prototype, "Mode", {
            get: function () {
                return this._mode == null ? +this.SystemEditor.Mode : this._mode;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BaseEditor.prototype, "IsPreviewMode", {
            get: function () {
                return this._mode === EditorShowMode.Preview;
            },
            enumerable: true,
            configurable: true
        });
        BaseEditor.prototype.ResetMode = function () {
            this._mode = null;
        };
        BaseEditor.prototype.CommonGetIsReadonlyEventHandler = function (sheetId, tableId, fieldId, isReadonly) {
            if (this.IsPreviewMode) {
                return true;
            }
            else {
                return isReadonly;
            }
        };
        BaseEditor.prototype.CommonGetIsVisibleEventHandler = function (sheetId, tableId, fieldId, isVisible) {
            if (this.IsPreviewMode) {
                return true;
            }
            else {
                return isVisible;
            }
        };
        BaseEditor.prototype.CommonGetButtonVisible = function (tableId, fieldId, buttonId, isVisible) {
            switch (this.Mode) {
                case EditorShowMode.Preview:
                    return buttonId.indexOf("PreviewButton") > -1;
                default:
                    return isVisible;
            }
        };
        BaseEditor.prototype.GetMainButtonVisible = function (tableId, fieldId, buttonId, isVisible) {
            switch (buttonId) {
                case ClientButton.EditorOkButton.Id:
                    return !this.IsPreviewMode;
                default:
                    return true;
            }
        };
        BaseEditor.prototype.GetMainButtonCaption = function (tableId, fieldId, buttonId, caption) {
            switch (buttonId) {
                case ClientButton.EditorCancelButton.Id:
                    return this.IsPreviewMode ? "OK" : ClientButton.EditorCancelButton.DefaultCaption;
                default:
                    return caption;
            }
        };
        BaseEditor.prototype.Show = function (mode) {
            this._mode = mode;
            var result;
            switch (mode) {
                case EditorShowMode.Create:
                    result = this.SystemEditor.Show(EditorMode.Create);
                    break;
                case EditorShowMode.Edit:
                    result = this.SystemEditor.Show(EditorMode.Edit);
                    break;
                default:
                    result = this.SystemEditor.Show();
            }
            this.ResetMode();
            return result;
        };
        return BaseEditor;
    }(BaseObject));
    FOutlay.BaseEditor = BaseEditor;
    var AnalyticsDataPart5sp3Editor = (function (_super) {
        __extends(AnalyticsDataPart5sp3Editor, _super);
        function AnalyticsDataPart5sp3Editor(id, _document, _filterKBK) {
            var _this = _super.call(this, id, _document) || this;
            _this._document = _document;
            _this._filterKBK = _filterKBK;
            _this._sourceTable = ObasTableCollection.RroOutlaySumByAnalyticsPart5xxTable;
            _this._isUniqueKBK = true;
            return _this;
        }
        Object.defineProperty(AnalyticsDataPart5sp3Editor.prototype, "SourceTable", {
            get: function () {
                return this._sourceTable;
            },
            enumerable: true,
            configurable: true
        });
        AnalyticsDataPart5sp3Editor.prototype.GetKbkFullCode = function () {
            return this.SourceTable.CalcKBKFullCode().replace(/null/g, "");
        };
        AnalyticsDataPart5sp3Editor.prototype.FilterKBK = function () {
            var filterTable = ObasTableCollection.RroOutlaySumByAnalyticsFilterTable;
            var rroDataTable = this.SourceTable.GetRroDataTable(filterTable.RroOutlayFieldId.Value);
            var result = ObasHelper.CheckPartialCode(rroDataTable.CostType.Code, this._filterKBK, 3);
            return result && (rroDataTable.RroOutlayKey.Value === filterTable.RroOutlayKey.Value);
        };
        AnalyticsDataPart5sp3Editor.prototype.IsOutlayData = function () {
            var filterTable = ObasTableCollection.RroOutlaySumByAnalyticsFilterTable;
            return this.SourceTable.RroOutlay.ForeignKey.Id === filterTable.RroOutlayFieldId.Value;
        };
        AnalyticsDataPart5sp3Editor.prototype.IsSumOutlayData = function () {
            var filterTable = ObasTableCollection.RroOutlaySumByAnalyticsFilterTable;
            return this.SourceTable.RroSumOutlay.ForeignKey.Id === filterTable.RroOutlayFieldId.Value;
        };
        AnalyticsDataPart5sp3Editor.prototype.EditFieldEventHandler = function (sheetId, fieldId, newValue, oldValue) {
            if (fieldId === "RRO_Data_ID" || fieldId === "RRO_SumData_ID") {
                var filterTable = ObasTableCollection.RroOutlaySumByAnalyticsFilterTable;
                var rroOutlayFieldId = filterTable.RroOutlayFieldId.Value;
                var rroOutlayKey = filterTable.RroOutlayKey.Value;
                this._isUniqueKBK = this.SourceTable.IsUniqueKBK(rroOutlayFieldId, rroOutlayKey);
                for (var i = 0; i <= ObasStageSettings.YearsCount - 1; i++) {
                    var yearFieldId = "Y" + (i + 1);
                    this.SourceTable.SetFieldValue(yearFieldId, this.SourceTable.GetLimitSumByKBK(rroOutlayFieldId, rroOutlayKey, yearFieldId));
                }
            }
            return true;
        };
        AnalyticsDataPart5sp3Editor.prototype.CanCloseEventHandler = function (buttonResult) {
            var isCorrectSums = true;
            if (buttonResult === MessageResults.Cancel) {
                return true;
            }
            else {
                if (!this._isUniqueKBK) {
                    Client.ShowMessage("\u041E\u0448\u0438\u0431\u043A\u0430", "\u0423\u0436\u0435 \u0441\u0443\u0449\u0435\u0441\u0442\u0432\u0443\u0435\u0442 \u0441\u0442\u0440\u043E\u043A\u0430 \u0441 \u041A\u0411\u041A = \"" + this.GetKbkFullCode() + "\"", MessageIcons.Error);
                }
                else {
                    for (var i = 0; i <= ObasStageSettings.YearsCount - 1; i++) {
                        var yearFieldId = "Y" + (i + 1);
                        var sum = this.SourceTable.GetFieldValue(yearFieldId);
                        var filterTable = ObasTableCollection.RroOutlaySumByAnalyticsFilterTable;
                        var limitSum = this.SourceTable.GetLimitSumByKBK(filterTable.RroOutlayFieldId.Value, filterTable.RroOutlayKey.Value, yearFieldId);
                        isCorrectSums = (sum <= limitSum);
                        if (!isCorrectSums) {
                            var year = ObasStageSettings.CurrentYear + i;
                            Client.ShowMessage("\u041E\u0448\u0438\u0431\u043A\u0430", "\u0412\u0432\u0435\u0434\u0435\u043D\u043D\u0430\u044F \u0441\u0443\u043C\u043C\u0430 \u043D\u0430 " + year + " \u0433\u043E\u0434 \u043F\u0440\u0435\u0432\u044B\u0448\u0430\u0435\u0442 \u0441\u0443\u043C\u043C\u0443 \u0432 \u043F\u043E\u043A\u0430\u0437\u0430\u0442\u0435\u043B\u044F\u0445 \u0431\u044E\u0434\u0436\u0435\u0442\u043D\u043E\u0439 \u0441\u043C\u0435\u0442\u044B \u043D\u0430 " + year + " \u0433\u043E\u0434.\n\u041C\u0430\u043A\u0441\u0438\u043C\u0430\u043B\u044C\u043D\u0430\u044F \u0441\u0443\u043C\u043C\u0430 \u0434\u043B\u044F \u0432\u0432\u043E\u0434\u0430 - " + ObasHelper.ConvertToString(limitSum, 2).replace(",", "."), MessageIcons.Error);
                            break;
                        }
                    }
                }
                return (this._isUniqueKBK && isCorrectSums && buttonResult === MessageResults.Ok);
            }
        };
        AnalyticsDataPart5sp3Editor.prototype.CloseEventHandler = function (isSuccess) {
            if (isSuccess) {
                var filterTable = ObasTableCollection.RroOutlaySumByAnalyticsFilterTable;
                this.SourceTable.SetFieldValue(filterTable.RroOutlayFieldId.Value, filterTable.RroOutlayKey.Value);
            }
        };
        return AnalyticsDataPart5sp3Editor;
    }(BaseEditor));
    FOutlay.AnalyticsDataPart5sp3Editor = AnalyticsDataPart5sp3Editor;
})(FOutlay || (FOutlay = {}));
