var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F06200;
(function (F06200) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP1Data("\u0418\u0422\u041E\u0413\u0418"));
            result.push(this.GetP2Sp1Data("\u0424\u0430\u043A\u0442\u043E\u0440\u044B1"));
            result.push(this.GetP3Sp1Data("\u0424\u0430\u043A\u0442\u043E\u0440\u044B2"));
            result.push(this.GetP4Sp1Data("\u0424\u0430\u043A\u0442\u043E\u0440\u044B3"));
            result.push(this.GetP2Sp1DetailData("\u0424\u0430\u043A\u0442\u043E\u0440\u044B_\u0421\u0443\u04311"));
            result.push(this.GetP3Sp1DetailData("\u0424\u0430\u043A\u0442\u043E\u0440\u044B_\u0421\u0443\u04312"));
            result.push(this.GetNpaData(this._document.TableP2Sp2Npa, "\u041D\u041F\u04101"));
            result.push(this.GetNpaData(this._document.TableP3Sp2Npa, "\u041D\u041F\u04102"));
            result.push(this.GetNpaData(this._document.TableP4Sp2Npa, "\u041D\u041F\u04103"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetRaspredelenieKosguData("\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041F\u043E\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push({ Id: "\u041E\u0431\u044A\u0435\u043C_\u0411\u0410_\u043F\u043E_\u0443\u0447\u0440\u0435\u0436\u0434\u0435\u043D\u0438\u044F\u043C", Data: null });
            return result;
        };
        ExportRules.prototype.GenYearData = function (srcTable, fieldId, startIndex) {
            var result = "";
            for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                result += "b" + (startIndex + j) + "=\"" + (srcTable.GetFieldValue(fieldId + j.toString()) || 0) + "\" ";
            }
            return result;
        };
        ExportRules.prototype.GetP1Data = function (barsTableId) {
            var srcTable = this._document.TableP1;
            var srcData = [];
            var i = 1;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                if (!srcTable.IsTotal) {
                    var template = "<a ID=\"" + ObasHelper.FillWithCharacter(i.toString(), 2) + "\" ";
                    for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                        template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue("Y" + (j + 1).toString()) || 0) + "\" ";
                    }
                    template += "/>";
                    srcData.push(template);
                    i++;
                }
            }
            srcData.push("<a ID=\"100\" b3=\"0\" b4=\"0\" b5=\"0\" />");
            for (var i = 1; i <= ObasStageSettings.YearsCount + 1; i++) {
                srcData.push("<c ID=\"SUM_" + i + "\" />");
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Sp1Data = function (barsTableId) {
            var dataTable = this._document.TableP2Sp1;
            var srcTable = this._document.TransTableP2Sp1;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                dataTable.Locate(dataTable.Subsidie.ForeignKey.Id, srcTable.GetFieldValue(dataTable.Subsidie.ForeignKey.Id));
                var template = "<a ID=\"" + i + "\" ";
                template += this.GenYearData(srcTable, dataTable.BudgetSum.Id, 4);
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "bFILTERINGCOLUMN=\"" + (srcTable.RecordKey.Value) + "\" ";
                template += "b7=\"" + ((dataTable.Subsidie.Code || "")) + "\" ";
                template += "b7_clone=\"" + ((dataTable.Subsidie.Code || "")) + "\" ";
                template += "b8=\"" + ((dataTable.Subsidie.Name || "")) + "\" ";
                template += "b9=\"\" ";
                template += "bMETAID=\"" + (srcTable.GetFieldValue("Id")) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3Sp1Data = function (barsTableId) {
            var dataTable = this._document.TableP3Sp1;
            var subsTable = this._document.TransTableP3Sp1;
            var srcTable = this._document.TransTableP3Sp1Values;
            var srcData = [];
            var i = 0;
            var yearsCount = ObasStageSettings.YearsCount;
            var reader = subsTable.CreateReader();
            while (reader.Read()) {
                var subsKey = subsTable.GetFieldValue(dataTable.SubKey.ForeignKey.Id);
                if (subsKey != null) {
                    var srcDataArr = new Array(yearsCount);
                    while (srcTable.Locate(dataTable.SubKey.ForeignKey.Id, subsKey, true)) {
                        for (var j = 0; j < yearsCount; j++) {
                            srcDataArr[j] = (srcDataArr[j] || 0) + (srcTable.GetFieldValue("g9" + j.toString()) || 0);
                        }
                    }
                    srcTable.ClearLocateFlag();
                    dataTable.Locate(dataTable.SubKey.ForeignKey.Id, subsKey);
                    var template = "<a ID=\"" + i + "\" ";
                    for (var j = 0; j < srcDataArr.length; j++) {
                        template += "b" + (4 + j) + "=\"" + (srcDataArr[j] || 0) + "\" ";
                    }
                    template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                    template += "bFILTERINGCOLUMN=\"" + (subsTable.RecordKey.Value) + "\" ";
                    template += "b7=\"" + ((dataTable.SubKey.Code || "")) + "\" ";
                    template += "b7_clone=\"" + ((dataTable.SubKey.Code || "")) + "\" ";
                    template += "b8=\"" + ((dataTable.SubKey.Name || "")) + "\" ";
                    template += "b9=\"\" ";
                    template += "bMETAID=\"" + (subsTable.GetFieldValue("Id")) + "\" ";
                    template += "/>";
                    srcData.push(template);
                    i++;
                }
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP4Sp1Data = function (barsTableId) {
            var srcTable = this._document.TableP4Sp1;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue("Y" + j.toString()) || 0) + "\" ";
                }
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "bFILTERINGCOLUMN=\"" + (srcTable.RecordKey.Value) + "\" ";
                template += "b7=\"" + ((srcTable.Subsidie.Code || "")) + "\" ";
                template += "b7_clone=\"" + ((srcTable.Subsidie.Code || "")) + "\" ";
                template += "b8=\"" + ((srcTable.Subsidie.Name || "")) + "\" ";
                template += "b9=\"\" ";
                template += "bMETAID=\"" + (srcTable.GetFieldValue("Id")) + "\" ";
                template += "b10=\"\" b10_clone=\"\" />";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Sp1DetailData = function (barsTableId) {
            var dataTable = this._document.TableP2Sp1;
            var srcTable = this._document.TransTableP2Sp1;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((srcTable.GetFieldValue(dataTable.RecipientCategory.Id) || "")) + "\" ";
                template += this.GenYearData(srcTable, dataTable.RecipientCount.Id, 3);
                template += this.GenYearData(srcTable, dataTable.Payment.Id, 7);
                template += this.GenYearData(srcTable, dataTable.BudgetSum.Id, 11);
                template += "bFILTERINGCOLUMN=\"" + (srcTable.RecordKey.Value) + "\" ";
                template += "b14=\"\" b14_clone=\"\" />";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3Sp1DetailData = function (barsTableId) {
            var subsTable = this._document.TransTableP3Sp1;
            var dataTable = this._document.TableP3Sp1Values;
            var srcTable = this._document.TransTableP3Sp1Values;
            var srcData = [];
            var i = 0;
            var subsFieldId = this._document.TableP3Sp1.SubKey.ForeignKey.Id;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                subsTable.Locate(subsFieldId, srcTable.GetFieldValue(subsFieldId));
                var template = "<a ID=\"" + i + "\" ";
                template += "b\u043A\u0430\u0442\u0435\u0433\u043E\u0440\u0438\u044F=\"" + ((srcTable.GetFieldValue(dataTable.RecipientName.Id) || "")) + "\" ";
                template += this.GenYearData(srcTable, dataTable.RecipientCount.Id, 3);
                template += this.GenYearData(srcTable, dataTable.SquarePrice.Id, 7);
                template += this.GenYearData(srcTable, dataTable.Square.Id, 11);
                template += this.GenYearData(srcTable, dataTable.Payment.Id, 15);
                template += this.GenYearData(srcTable, dataTable.BudgetSum.Id, 19);
                template += "bFILTERINGCOLUMN=\"" + (subsTable.RecordKey.Value) + "\" ";
                template += "b22=\"\" b22_clone=\"\" />";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetNpaData = function (srcTable, barsTableId) {
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (srcTable.Subsidie.Code || "") + "\" ";
                template += "b2=\"" + (srcTable.Subsidie.Name || "") + "\" ";
                template += "b7=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                template += "b9=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b10=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b11=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b12=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "b\u042F\u0432\u043B\u044F\u0435\u0442\u0441\u044F\u0421\u043A\u043E\u043F\u0438\u0440\u043E\u0432\u0430\u043D\u043D\u043E\u0439=\"False\" />";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var srcData = [];
            for (var i = 0; i < kosguData.length; i++) {
                var template = "<a ID=\"" + ((kosguData[i].Code === "-") ? "200" : kosguData[i].Code) + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (3 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetRaspredelenieKosguData = function (id, kosguData) {
            var srcData = [];
            for (var i = 0; i < kosguData.length; i++) {
                var template = "<a ID=\"" + ((kosguData[i].Code === "-") ? "200" : kosguData[i].Code) + "\" b3=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" />";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F06200.ExportRules = ExportRules;
})(F06200 || (F06200 = {}));
